// File name ubitx_CW_Options.cpp


#include <Arduino.h>
#include <ili9341_t3n_font_Arial.h>
#include <ili9341_t3n_font_ArialBold.h>
#include <ILI9341_t3n.h>
#include <XPT2046_Touchscreen.h>
#include <SPIN.h>
#include <SD.h>
#include <TimeLib.h>
#include "USBHost_t36.h"
#include "ubitx.h"

extern ILI9341_t3n tft;
extern XPT2046_Touchscreen ts;
extern void Fake_Delay(void);

extern void Get_Touch( bool wait );
void Init_Screen();
extern void updateDisplay(void);
extern void Display_RIT(void);
extern void menuSetupCwTone( void );
extern bool Set_Left_Button_Pressed( void );
extern void Get_Mouse_Data( void );
extern void Save_Mouse( void );
extern void Remove_Mouse( void );


extern TS_Point p;
extern MouseController uBITX_Mouse;

extern void menuIambicToggle( void );
extern void menuPaddleSwapToggle( void );

extern void Process_Reboot();
extern int  enc_read(void);
extern bool Put_SDEEPROM( int index, long Value );
extern long Get_SDEEPROM( int index );

extern char c[21], b[21];



extern bool Menu_Changed;

extern XPT2046_Touchscreen ts;




bool CW_Filter_Present = false;
bool CW_Calibrated = false;
unsigned long CW_Filter_Offset = 0;

void Do_CW_Filter_Toggle(void) {

  CW_Filter_Present = Get_SDEEPROM( CW_FILTER_PRESENT );
  if (CW_Filter_Present > 0 ) CW_Filter_Present = 0;
  else CW_Filter_Present = 1;
  Put_SDEEPROM( CW_FILTER_PRESENT, CW_Filter_Present );
  CW_Filter_Present = Get_SDEEPROM( CW_FILTER_PRESENT );
  Menu_Changed = true;
}




extern unsigned long sideTone;

void Display_CW_Options_Menu( void) {
  char buf[40];
  unsigned char fake_swap;

  Remove_Mouse();
  tft.drawRect(138, 72, 172, 145,  ILI9341_WHITE);
  tft.fillRect(139, 73, 170, 143, ILI9341_BLUE);
  tft.setFont(Arial_16);
  tft.setTextColor(ILI9341_WHITE);
  tft.setCursor(141, 78);
  sprintf(buf, "Tone = [%03d]", (int)sideTone);
  tft.println(buf);
  tft.setCursor(141, 108);
  if ( CW_Filter_Present == 0 ) tft.println((char*)"CW Filter [OFF]");
  else tft.println((char*)"CW Filter [ON]");
  tft.setCursor(141, 138);
  fake_swap =   Get_SDEEPROM( PDL_SWAP_VAL );
  if (fake_swap != 0 ) {
    tft.setTextColor(ILI9341_RED);
    tft.fillRect(141, 138, 166, 20, ILI9341_WHITE);
    tft.println((char*)"[Reverse] Paddle");
  } else tft.println((char*)"[Normal] Paddle");
  tft.setTextColor(ILI9341_WHITE);
  tft.setCursor(141, 168);
  fake_swap =   Get_SDEEPROM( IAMBIC_MODE );
  if (fake_swap == 0 )tft.println((char*)"Iambic [A]");
  else tft.println((char*)"Iambic [B]");
  tft.setCursor(141, 198);
  tft.setFont(Arial_16_Bold);
  tft.println((char*)"EXIT");
  if ((p.x > 138) && (p.x < 310) && (p.y > 72) && (p.y < 217))Save_Mouse();

}
///////////////////////////////////////////////////////////////////
bool Execute_CW_Options( void) {
  bool Menu_Changed = false;
  bool retval = true;

  if (      (p.x > 140) && (p.x < 300) && (p.y > 78) && (p.y < 98)) {
    menuSetupCwTone();
    Menu_Changed = true;
  }
  else if ( (p.x > 140) && (p.x < 300) && (p.y > 108) && (p.y < 128)) {
    Do_CW_Filter_Toggle();
    Menu_Changed = true;
  }
  else if ( (p.x > 140) && (p.x < 300) && (p.y > 138) && (p.y < 158)) {
    menuPaddleSwapToggle();
    Menu_Changed = true;
  }
  else if ( (p.x > 140) && (p.x < 300) && (p.y > 168) && (p.y < 188)) {
    menuIambicToggle();
    Menu_Changed = true;
  }
  else if ( (p.x > 140) && (p.x < 300) && (p.y > 198) && (p.y < 218)) retval = false;

  if ( Menu_Changed == true ) {
    Menu_Changed = false;
    Display_CW_Options_Menu();

  }
  return (retval);
}

///////////////////////////////////////////////////////////////////
void Do_Mouse_CW_Options(void) {
  bool looper = true;

  tft.fillScreen(ILI9341_BLUE);
  Display_CW_Options_Menu();
  while ( looper ) {
    if (ts.touched()) {
      Get_Touch( true );
      looper = Execute_CW_Options();
    }
    if (Set_Left_Button_Pressed() == 1) {
      while ( Set_Left_Button_Pressed() == 1) Fake_Delay();
      looper = Execute_CW_Options();
    }
  }
}


