// File name ubitx_Configuration.cpp


#include <Arduino.h>
#include <ili9341_t3n_font_Arial.h>
#include <ili9341_t3n_font_ArialBold.h>
#include "USBHost_t36.h"
#include <ILI9341_t3n.h>
#include <XPT2046_Touchscreen.h>
#include <SPIN.h>
#include <SD.h>
#include <TimeLib.h>
#include "ubitx.h"

extern ILI9341_t3n tft;
extern MouseController uBITX_Mouse;
extern void Get_Touch( bool wait );
extern TS_Point p;
extern volatile int LastSmeter;

extern void Process_Reboot();
extern int  enc_read(void);
extern bool Put_SDEEPROM( int index, long Value );
extern long Get_SDEEPROM( int index );
extern bool Set_Left_Button_Pressed( void );
extern void   Get_Mouse_Data( int size );
extern void   Get_Mouse_Data( void );
extern void   Save_Mouse( void );
extern void   Remove_Mouse( void );
extern void Update_Mouse( void);
extern int Get_Mouse_Wheel_Value(void);
extern void Fake_Delay(void);

extern char c[21], b[21];
extern unsigned long frequency;
extern volatile unsigned long Ubitx_Voltage;
extern volatile unsigned long Current_Ubitx_Voltage;
extern volatile unsigned long Converted_Ubitx_Voltage;
extern unsigned long Volt_Divider;
extern bool Volts_Active;
extern bool Smeter_Active;
extern bool Clock_Active;
extern char printBuff[4][21];
extern int mouse_left_button;

bool Menu_Changed = false;





extern XPT2046_Touchscreen ts;



float temp_value;




void Display_Trangle(int xstart, int ystart, int width, int height, uint16_t color) {
  tft.drawTriangle(xstart, ystart, xstart + (width / 2), ystart + height, xstart + width, ystart,  color);
  if ( height > 0 )
    tft.fillTriangle(xstart + 1, ystart + 1, xstart + (width / 2), ystart + height - 1, xstart + width - 1, ystart + 1, color);
  else
    tft.fillTriangle(xstart + 1, ystart - 1, xstart + (width / 2), ystart + height + 1, xstart + width - 1, ystart - 1, color);
}


void display_value(void) {
  char Voltage_Text[21];


  itoa(Volt_Divider, Voltage_Text, 10);
  //   printLine3(Voltage_Text);
  Ubitx_Voltage = analogRead(UBIT_VCC);
  Converted_Ubitx_Voltage = (Ubitx_Voltage * (unsigned long)1500);
  Ubitx_Voltage = analogRead(UBIT_VCC);
  temp_value = Ubitx_Voltage;
  temp_value = (temp_value * 15.0);
  temp_value = temp_value  / (float)Volt_Divider;
  tft.setFont(Arial_20);
  tft.fillRect(6, 100, 160, 50, ILI9341_BLUE);
  sprintf(c, "VCC = %02.1fV", temp_value );
  tft.setTextColor(ILI9341_WHITE);
  tft.setCursor(6, 100);
  tft.print(c);
  sprintf(c, (char*)"Cal Factor = %d", (int)Volt_Divider);
  tft.fillRect(6, 130, 224, 30, ILI9341_BLUE);
  tft.setTextColor(ILI9341_WHITE);
  tft.setCursor(6, 130);
  tft.print(c);
  if ( (p.x > 6) && (p.x < 230) && (p.y > 130) && (p.y < 160) )Save_Mouse();
}

void Menu_Setup_Volts( void ) {
  bool looper = true;
  int wheel = 0;

  // remove menu and display volts setup menu
  tft.fillScreen(ILI9341_BLUE);
  Save_Mouse();
  tft.drawRect(2, 10, 260, 170, ILI9341_WHITE);
  tft.fillRect(3, 11, 258, 168, ILI9341_BLUE);

  Display_Trangle(232, 135, 20, -20, ILI9341_GREEN);
  Display_Trangle(232, 140, 20, 20, ILI9341_RED);

  tft.setFont(Arial_14);
  tft.setTextColor(ILI9341_WHITE);
  tft.setCursor(40, 20);
  tft.print((char *)"MATCH YOUR VCC");
  tft.setCursor(6, 40);
  tft.print((char *)"Touch: Use arrows");
  tft.setCursor(6, 60);
  tft.print((char *)"Mouse: Use wheel");
  tft.drawRect(175, 39, 72, 26, ILI9341_WHITE);
  tft.drawRect(176, 40, 70, 24, ILI9341_WHITE);
  tft.fillRect(177, 41, 68, 22, ILI9341_YELLOW);
  tft.setFont(Arial_16_Bold);
  tft.setCursor(181, 44);
  tft.setTextColor(ILI9341_BLUE);
  tft.print((char *)"Save");

  Volt_Divider = Get_SDEEPROM( VOLT_DIVIDE );
  if (  (Volt_Divider > 2000) || (Volt_Divider < 0))Volt_Divider = 982;
  display_value();

  while ( looper ) {
    // Using touch screen
    if (ts.touched()) {
      Get_Touch(false);
      if ( (p.x > 160) && (p.x < 280) && (p.y > 30) && (p.y < 70) )looper = false;
      if ( (p.x > 230) && (p.x < 280) && (p.y > 110) && (p.y < 135) ) {
        looper = Volt_Divider--;
        display_value();
        delay(500);
      }
      if ( (p.x > 230) && (p.x < 280) && (p.y > 135) && (p.y < 160) ) {
        looper = Volt_Divider++;
        display_value();
        delay(500);
      }
      while ( ts.touched()) {
        Get_Touch(false);
        if ( (p.x > 230) && (p.x < 280) && (p.y > 110) && (p.y < 135) ) {
          looper = Volt_Divider--;
          display_value();
        }
        if ( (p.x > 230) && (p.x < 280) && (p.y > 135) && (p.y < 160) ) {
          looper = Volt_Divider++;
          display_value();
        }
        delay(100);
      }
    }
    // Using Mouse
    //Get_Mouse_Data();
    wheel = Get_Mouse_Wheel_Value();
    if ( mouse_left_button && ((p.x > 160) && (p.x < 280) && (p.y > 30) && (p.y < 70)) )looper = false;
    if (wheel == 1) {
      looper = Volt_Divider--;
      display_value();
      delay(100);
    } else if (wheel == -1) {
      looper = Volt_Divider++;
      display_value();
      delay(100);
    }
  }

  Put_SDEEPROM( VOLT_DIVIDE, Volt_Divider );
  tft.fillScreen(ILI9341_BLACK);

  Menu_Changed = true;

}


int get_number(int indexx, int indexy, int min, int max , int start_value) {
  int answer;
  int i;
  char numbr[5];

  answer = start_value;
  sprintf(numbr, "%02d", answer);
  tft.fillRect(indexx, indexy, 100, 16, ILI9341_BLUE);
  tft.setCursor(indexx, indexy);
  tft.print(numbr);

  while ( (digitalRead(FBUTTON) == HIGH) && (Set_Left_Button_Pressed() == 0) ) {
    delay(50);
    i = enc_read();
    if ( i == 0 )i = Get_Mouse_Wheel_Value();
    if ( i != 0) {
      if (i >= 1) {
        answer++;
        if ( answer > max) answer = max;
      } else if (i <= -1 ) {
        answer--;
        if ( answer < min ) answer = min;
      }
      sprintf(numbr, "%02d", answer);
      tft.fillRect(indexx, indexy,  100, 20, ILI9341_BLUE);
      tft.setCursor(indexx, indexy);
      tft.print(numbr);
    }
  }
  while ( digitalRead(FBUTTON) == LOW ) delay(10);
  while ( Set_Left_Button_Pressed() == 1 ) delay(10);
  return ( answer);
}

int Time_Month = 5, Time_Day = 20, Time_Year = 2018, Time_Hour = 13, Time_Minute = 14;




void Menu_Set_Time( void ) {
  char Time_Now[17];
  int s;


  tft.fillScreen(ILI9341_BLUE);
  tft.setFont(Arial_14);
  tft.setCursor(12, 140);
  tft.print((char*)"Use encoder press to advance");
  tft.setFont(Arial_16);



  sprintf(Time_Now, "%02d/%02d/%4d %02d:%02d", Time_Month, Time_Day, Time_Year, Time_Hour, Time_Minute);
  tft.setTextColor(ILI9341_WHITE);
  tft.setCursor(12, 60);
  tft.print(Time_Now);
  tft.setCursor(12, 60);
  tft.print(Time_Now);

  tft.setCursor(10, 110);
  tft.print((char*)"Select Month (encoder):");
  Save_Mouse();
  if ( (Time_Month = get_number(260, 110, 0, 12, Time_Month)) < 0 )return;
  //-------------------------------------------
  sprintf(Time_Now, "%02d/%02d/%4d %02d:%02d", Time_Month, Time_Day, Time_Year, Time_Hour, Time_Minute);
  tft.setTextColor(ILI9341_WHITE);
  tft.fillRect(12, 60, 200, 20, ILI9341_BLUE);
  tft.setCursor(12, 60);
  tft.print(Time_Now);
  tft.fillRect(10, 110, 280, 20, ILI9341_BLUE);
  tft.setCursor(10, 110);
  tft.print((char*)"Select Day (encoder):");
  if ( (Time_Day = get_number(260, 110, 0, 31, Time_Day)) < 0 )return;
  //-------------------------------------------
  sprintf(Time_Now, "%02d/%02d/%4d %02d:%02d", Time_Month, Time_Day, Time_Year, Time_Hour, Time_Minute);
  tft.setTextColor(ILI9341_WHITE);
  tft.fillRect(12, 60, 200, 20, ILI9341_BLUE);
  tft.setCursor(12, 60);
  tft.print(Time_Now);
  tft.fillRect(10, 110, 280, 20, ILI9341_BLUE);
  tft.setCursor(10, 110);
  tft.print((char*)"Select Year (encoder):");
  if ( (Time_Year = get_number(260, 110, 0, 9999, Time_Year)) < 0 )return;
  //-------------------------------------------
  sprintf(Time_Now, "%02d/%02d/%4d %02d:%02d", Time_Month, Time_Day, Time_Year, Time_Hour, Time_Minute);
  tft.setTextColor(ILI9341_WHITE);
  tft.fillRect(12, 60, 200, 20, ILI9341_BLUE);
  tft.setCursor(12, 60);
  tft.print(Time_Now);
  tft.fillRect(10, 110, 280, 20, ILI9341_BLUE);
  tft.setCursor(10, 110);
  tft.print((char*)"Select Hour (encoder):");
  if ( (Time_Hour = get_number(260, 110, 0, 23, Time_Hour)) < 0)return;
  //-------------------------------------------
  sprintf(Time_Now, "%02d/%02d/%4d %02d:%02d", Time_Month, Time_Day, Time_Year, Time_Hour, Time_Minute);
  tft.setTextColor(ILI9341_WHITE);
  tft.fillRect(12, 60, 200, 20, ILI9341_BLUE);
  tft.setCursor(12, 60);
  tft.print(Time_Now);
  tft.fillRect(10, 110, 280, 20, ILI9341_BLUE);
  tft.setCursor(10, 110);
  tft.print((char*)"Select Minute (encoder):");
  if ( (Time_Minute = get_number(260, 110, 0, 59, Time_Minute)) < 0 )return;
  sprintf(Time_Now, "%02d/%02d/%4d %02d:%02d", Time_Month, Time_Day, Time_Year, Time_Hour, Time_Minute);
  tft.setTextColor(ILI9341_WHITE);
  tft.fillRect(12, 60, 200, 20, ILI9341_BLUE);
  tft.setCursor(12, 60);
  tft.print(Time_Now);
  tft.fillRect(10, 110, 280, 20, ILI9341_BLUE);
  tft.setCursor(10, 110);

  //draw buttons
  tft.drawRect(9, 109, 111, 27, ILI9341_BLACK);
  tft.fillRect(11, 111, 108, 24, ILI9341_YELLOW);
  tft.setCursor(13, 115);
  tft.setTextColor(ILI9341_BLACK);
  tft.print((char*)"SET TIME");
  tft.drawRect(129, 109, 111, 27, ILI9341_BLACK);
  tft.drawRect(130, 110, 110, 26, ILI9341_RED);
  tft.fillRect(131, 111, 108, 24, ILI9341_YELLOW);
  tft.setCursor(133, 115);
  tft.setTextColor(ILI9341_RED);
  tft.print((char*)"  ABORT");


  s = 1;
  while ( s > 0 ) {
    if (ts.touched()) {
      delay(100);
      Get_Touch( true );
      if ( (p.x > 9) && (p.x < 120) && (p.y > 109) && (p.y < 136)) {
        setTime(Time_Hour, Time_Minute, 0, Time_Day, Time_Month, Time_Year);
        Teensy3Clock.set(now());
        s = 0;
      } else if ( (p.x > 129) && (p.x < 240) && (p.y > 109) && (p.y < 136)) s = 0;
    }
    if (Set_Left_Button_Pressed() == 1) {
      if ( (p.x > 9) && (p.x < 120) && (p.y > 109) && (p.y < 136)) {
        setTime(Time_Hour, Time_Minute, 0, Time_Day, Time_Month, Time_Year);
        Teensy3Clock.set(now());
        s = 0;
      } else if ( (p.x > 129) && (p.x < 240) && (p.y > 109) && (p.y < 136)) s = 0;
      while (Set_Left_Button_Pressed() == 1)Fake_Delay();
    }
  }
  tft.fillScreen(ILI9341_BLACK);
  Menu_Changed = true;
  Save_Mouse();
}


void Do_Clock_Toggle(void) {

  Clock_Active = Get_SDEEPROM( CLOCK_ACTIVE );
  if (Clock_Active > 0 ) Clock_Active = 0;
  else Clock_Active = 1;
  Put_SDEEPROM( CLOCK_ACTIVE, Clock_Active );
  Clock_Active = Get_SDEEPROM( CLOCK_ACTIVE );
  Menu_Changed = true;

}

void Do_Volts_Toggle(void) {

  Volts_Active = Get_SDEEPROM( VOLTS );
  if (Volts_Active > 0 ) Volts_Active = 0;
  else Volts_Active = 1;
  Put_SDEEPROM( VOLTS, Volts_Active );
  Volts_Active = Get_SDEEPROM( VOLTS );
  Menu_Changed = true;

}


void Do_Smeter_Toggle(void) {

  Smeter_Active = Get_SDEEPROM( SMETER_ACTIVE );
  if (Smeter_Active > 0 ) Smeter_Active = 0;
  else Smeter_Active = 1;
  Put_SDEEPROM( SMETER_ACTIVE, Smeter_Active );
  Smeter_Active = Get_SDEEPROM( SMETER_ACTIVE );
  Menu_Changed = true;
}



////////////////////////////////////////////////////
void Display_Configuration1_Menu( void) {
  char buf[40];


  Remove_Mouse();
  tft.fillScreen(ILI9341_BLUE);
  tft.drawRect(40, 42, 270, 175,  ILI9341_WHITE);
  tft.fillRect( 41, 43, 268, 173, ILI9341_BLUE);
  tft.setFont(Arial_16);
  tft.setTextColor(ILI9341_WHITE);


  if ( Volts_Active > 0 )sprintf(buf, "Volts Display [ ON ]" );
  else sprintf(buf, "Volts Display [ OFF ]");
  tft.setCursor(43, 48);
  tft.print(buf);

  sprintf(buf, "Calibrate Voltmeter");
  tft.setCursor(43, 78);
  tft.print(buf);

  Smeter_Active = Get_SDEEPROM( SMETER_ACTIVE );
  if ( (Smeter_Active < 0) || (Smeter_Active > 1)) Smeter_Active = 0;
  if ( Smeter_Active )sprintf(buf, "S-meter Display [ ON  ]" );
  else sprintf(buf, "S-meter Display [ OFF ]");
  tft.setCursor(43, 108);
  tft.print(buf);

  Clock_Active = Get_SDEEPROM( CLOCK_ACTIVE );
  if ( Clock_Active > 0 )sprintf(buf, "Set Clock [ ON  ]");
  else sprintf(buf, "Set Clock [ OFF ]");
  tft.setCursor(43, 138);
  tft.print(buf);


  tft.setCursor(43, 168);
  tft.print((char*)"Set Time");

  tft.setCursor(43, 198);
  tft.setFont(Arial_16_Bold);
  tft.println((char*)"EXIT");

  if((p.x > 40) && (p.x < 310) && (p.y > 42) && (p.y < 217))Save_Mouse();

}



int Process_Config1( void) {
  int ret_val = true;

    Menu_Changed = false;

  // process configuration buttons
  // Volts Display
  if ( (p.x > 35) && (p.x < 300) && (p.y > 48) && (p.y < 68)) {
    Do_Volts_Toggle();
    Menu_Changed = true;

    // Calibrate Voltmeter
  } else if ( (p.x > 35) && (p.x < 300) && (p.y > 78) && (p.y < 98)) {
    Menu_Setup_Volts();
    Menu_Changed = true;

    // S-Meter Display
  } else if ( (p.x > 35) && (p.x < 300) && (p.y > 108) && (p.y < 128)) {
    Do_Smeter_Toggle();
    Menu_Changed = true;

    // Set Clock Display
  } else if ( (p.x > 35) && (p.x < 300) && (p.y > 138) && (p.y < 158)) {
    Do_Clock_Toggle();
    Menu_Changed = true;

    // Set Time
  } else if ( (p.x > 35) && (p.x < 300) && (p.y > 168) && (p.y < 188)) {
    Menu_Set_Time();
    Menu_Changed = true;


    // Exit
  } else if ( (p.x > 35) && (p.x < 300) && (p.y > 198) && (p.y < 218)) ret_val = false;

  if ( Menu_Changed == true ) {
    Display_Configuration1_Menu();

  }
  return (ret_val);
}




void Do_Configuration1(void) {
  bool looper = true;


  tft.fillScreen(ILI9341_BLUE);
  Display_Configuration1_Menu();

  while ( looper ) {

    if (ts.touched()) {
      Get_Touch( true );
      looper = Process_Config1();
    } else if (Set_Left_Button_Pressed() == 1) {
      while ( Set_Left_Button_Pressed() == 1) Fake_Delay();
      Get_Mouse_Data();
      looper = Process_Config1();
    }
  }
  tft.fillScreen(ILI9341_BLUE);
  LastSmeter = 0;
 
}


