// File name ubitx_Configuration.cpp


#include <Arduino.h>
#include <ili9341_t3n_font_Arial.h>
#include <ili9341_t3n_font_ArialBold.h>
#include <ILI9341_t3n.h>
#include <XPT2046_Touchscreen.h>
#include <SPIN.h>
#include <SD.h>
#include <TimeLib.h>
#include "ubitx.h"

extern ILI9341_t3n tft;

extern void Get_Touch( bool wait );
extern TS_Point p;
extern volatile int LastSmeter;

extern void Process_Reboot();
extern int  enc_read(void);
extern bool Put_SDEEPROM( int index, long Value );
extern long Get_SDEEPROM( int index );
extern void Write_Default_Memory_Tables( void );
extern void Write_Default_USR_Table( void );
extern void Write_Entire_Band_Table_to_SD();
extern bool Set_Left_Button_Pressed( void );
extern void   Get_Mouse_Data( void );
extern void   Save_Mouse( void );
extern void Fake_Delay(void);

extern char c[21], b[21];
extern unsigned int SI5351BX_XTALPF;              // 1:6pf  2:8pf  3:10pf


extern bool Menu_Changed;
int ubitx_baud;
int Last_Baud;
char ubitx_CAT_Baud_rates[8][7] = {"1200", "2400", "4800", "9600", "19200", "38400", "57600", "115200"};
long ubitx_CAT_Long_Baud_rates[8] = {1200, 2400, 4800, 9600, 19200, 38400, 57600, 115200};




extern XPT2046_Touchscreen ts;


char Pf_Text[4][12] = { "XTAL  6pf", "XTAL  6pf", "XTAL  8pf", "XTAL 10pf"};



int minx = 10000, miny = 10000, maxx = 0, maxy = 0;
extern File fileptr;
extern   int rawxx, rawyy;
extern int CAL_Minx;
extern int CAL_Miny;
extern int CAL_Maxx;
extern int CAL_Maxy;






bool Really(void) {
  bool looper = true;
  bool return_value = false;

  tft.fillScreen(ILI9341_BLACK);

  tft.drawRect(5, 10, 300, 80, ILI9341_WHITE);
  tft.fillRect(6, 11, 298, 78, ILI9341_BLUE);
  tft.setFont(Arial_14_Bold);
  tft.setTextColor(ILI9341_WHITE);
  tft.setCursor(8, 20);
  tft.print((char *)"Do you really want to continue?");
  tft.fillRect(40, 60, 44, 24, ILI9341_WHITE);
  tft.setTextColor(ILI9341_BLUE);
  tft.setCursor(44, 64);
  tft.setTextColor(ILI9341_BLACK);
  tft.print((char *)"YES");
  tft.fillRect(140, 60, 44, 24, ILI9341_WHITE);
  tft.setTextColor(ILI9341_RED);
  tft.setCursor(144, 64);
  tft.print((char *)" NO ");

  while (Set_Left_Button_Pressed() == 1)delay(10);
  Save_Mouse();
  while ( looper ) {

    if (ts.touched()) {
      Get_Touch(false);
      if ( (p.x > 35) && (p.x < 65) && (p.y > 60) && (p.y < 80)) {
        looper = false;
        return_value = true;
      } else if ( (p.x > 135) && (p.x < 165) && (p.y > 60) && (p.y < 80)) {
        looper = false;
        return_value = false;
      }
    } else if ( Set_Left_Button_Pressed() == 1) {
      if ( (p.x > 35) && (p.x < 65) && (p.y > 60) && (p.y < 80)) {
        looper = false;
        return_value = true;
      } else if ( (p.x > 135) && (p.x < 165) && (p.y > 60) && (p.y < 80)) {
        looper = false;
        return_value = false;
      }
    }
  }
  while ( ts.touched()) delay(10);
  while ( Set_Left_Button_Pressed() == 1 ) Fake_Delay();
  tft.fillScreen(ILI9341_BLUE);
  Save_Mouse();
  return (return_value);

}



void Calibrate_Screen( void ) {
  File fileptr;
  bool looper = true;
  int i;
  int Screen_Calibration_Matrix[16][2];
  char buffr[32];
  char fred[7];


  while ( looper ) {
    tft.fillScreen(ILI9341_BLACK);
    tft.setFont(Arial_14);
    tft.setTextColor(ILI9341_WHITE);
    tft.fillCircle(5, 5, 3, ILI9341_WHITE);
    tft.setCursor(16, 140);
    tft.print((char *)"Dot in upper left corner");
    tft.setCursor(16, 170);
    tft.print((char *)"Press and Hold");
    // get Minx and Miny
    while (!ts.touched()) delay(10);
    i = 0;
    delay(100);
    while ( (i < 10) && ts.touched()) {
      p = ts.getPoint();
      Screen_Calibration_Matrix[i][0] = p.x;
      Screen_Calibration_Matrix[i][1] = p.y;
      i = i + 1;
      delay(100);
    }
    if ( i == 10 ) {
      tft.fillRect(16, 200, 200, 32, ILI9341_BLACK);
      tft.setCursor(16, 200);
      tft.print((char *)"RELEASE NOW");
      while (ts.touched())delay(10);
      for (i = 0; i < 10; i++) {
        if (Screen_Calibration_Matrix[i][0] < minx)minx = Screen_Calibration_Matrix[i][0];
        if (Screen_Calibration_Matrix[i][1] < miny)miny = Screen_Calibration_Matrix[i][1];
      }
      looper = false;
    } else {
      tft.setTextColor(ILI9341_RED);
      tft.setCursor(16, 200);
      tft.print((char *)"Failed to hold long enough");
      delay(2000);
    }
  }
  ////////////////////////////////
  looper = true;

  while ( looper ) {
    tft.fillScreen(ILI9341_BLACK);
    tft.setFont(Arial_14);
    tft.setTextColor(ILI9341_WHITE);
    tft.fillCircle(310, 230, 3, ILI9341_WHITE);
    tft.setCursor(16, 140);
    tft.print((char *)"Dot in lower right corner");
    tft.setCursor(16, 170);
    tft.print((char *)"Press and Hold");
    // get Maxx and Maxy
    while (!ts.touched()) delay(10);
    i = 0;
    delay(100);
    while ( (i < 10) && ts.touched()) {
      p = ts.getPoint();
      Screen_Calibration_Matrix[i][0] = p.x;
      Screen_Calibration_Matrix[i][1] = p.y;
      i = i + 1;
      delay(100);
    }
    if ( i == 10 ) {
      tft.fillRect(16, 200, 200, 32, ILI9341_BLACK);
      tft.setCursor(16, 200);
      tft.print((char *)"RELEASE NOW");
      while (ts.touched())delay(10);
      for (i = 0; i < 10; i++) {
        if (Screen_Calibration_Matrix[i][0] > maxx)maxx = Screen_Calibration_Matrix[i][0];
        if (Screen_Calibration_Matrix[i][1] > maxy)maxy = Screen_Calibration_Matrix[i][1];
      }
      looper = false;
    } else {
      tft.setTextColor(ILI9341_RED);
      tft.setCursor(16, 200);
      tft.print((char *)"Failed to hold long enough");
      delay(1500);
    }
  }

  /////////////////////////
  tft.fillScreen(ILI9341_BLACK);
  tft.setFont(Arial_14);
  tft.setTextColor(ILI9341_WHITE);
  sprintf(buffr, "MinX = %d  MaxX = %d", minx, maxx);
  tft.setCursor(40, 100);
  tft.print(buffr);
  sprintf(buffr, "MinY = %d  MaxY = %d", miny, maxy);
  tft.setCursor(40, 140);
  tft.print(buffr);
  tft.setTextColor(ILI9341_YELLOW);
  tft.setCursor(40, 180);
  tft.print("TAP SCREEN TO CONTINUE");
  while (!ts.touched()) delay(10);


  // try to open screen calibration file
  fileptr = SD.open("SCAL", FILE_WRITE);
  if ( fileptr ) {
    fileptr.close();
    SD.remove("SCAL");
    fileptr = SD.open("SCAL", FILE_WRITE);
    sprintf(fred, "%04d", minx);
    fileptr.write(fred);
    sprintf(fred, "%04d", maxx);
    fileptr.write(fred);
    sprintf(fred, "%04d", miny);
    fileptr.write(fred);
    sprintf(fred, "%04d", maxy);
    fileptr.write(fred);
    fileptr.close();
  } else {
    tft.setFont(Arial_20);
    tft.setTextColor(ILI9341_RED);
    tft.setCursor(40, 200);
    tft.print((char*)"SD FAIL");

  }
  CAL_Minx = minx;
  CAL_Miny = miny;
  CAL_Maxx = maxx;
  CAL_Maxy = maxy;



  while (ts.touched()) delay(100);


  tft.fillScreen(ILI9341_BLACK);
  Menu_Changed = true;

}



void Display_Configuration2_Menu( void) {
  char buf[40];


  tft.drawRect(40, 42, 270, 185,  ILI9341_WHITE);
  tft.fillRect( 41, 43, 268, 183, ILI9341_BLUE);
  tft.setFont(Arial_16);
  tft.setTextColor(ILI9341_WHITE);

  tft.setCursor(43, 48);
  tft.println("Initialize  SD");

  tft.setCursor(43, 78);
  tft.println("Set Default Memory Tables");

  tft.setCursor(43, 108);
  SI5351BX_XTALPF = Get_SDEEPROM( XTALPF );
  sprintf(buf, "OSC Load [ %s ]", Pf_Text[SI5351BX_XTALPF]);
  tft.println(buf);

  tft.setCursor(43, 138);
  sprintf(buf, "CAT Baud Rate [ %s ]", ubitx_CAT_Baud_rates[ubitx_baud]);
  tft.println(buf);

  tft.setCursor(43, 168);
  tft.print((char*)"Screen Cal");

  tft.setCursor(43, 198);
  tft.setFont(Arial_16_Bold);
  tft.println((char*)"EXIT");
  Save_Mouse();


}


void Do_OSC_Load(void) {

  SI5351BX_XTALPF = Get_SDEEPROM( XTALPF );
  SI5351BX_XTALPF = SI5351BX_XTALPF + 1;
  if ( SI5351BX_XTALPF > 3 ) SI5351BX_XTALPF = 0;
  Put_SDEEPROM( XTALPF, SI5351BX_XTALPF );
  Menu_Changed = true;
}



void Do_Baud_Select(void) {

  ubitx_baud++;
  Serial.println(ubitx_baud);
  if ( ubitx_baud > 7) ubitx_baud = 0;
  Serial.println(ubitx_baud);
  Serial.println(" ");
  Put_SDEEPROM( BAUDD, ubitx_baud );
  Menu_Changed = true;
}







bool Process_Config2(void) {
  bool retval = true;
  bool Menu_Changed = false;

  // Default USR Table
  if ( (p.x > 35) && (p.x < 300) && (p.y > 48) && (p.y < 68)) {
    tft.setFont(Arial_16);
    tft.fillRect(41, 47, 268, 23, ILI9341_WHITE);
    tft.setTextColor(ILI9341_RED);
    tft.setCursor(43, 48);
    tft.println("Writing USR Table");
    Write_Entire_Band_Table_to_SD();
    Write_Default_Memory_Tables();
    Write_Default_USR_Table();
    delay(1000);
    tft.fillRect(41, 47, 268, 23, ILI9341_BLUE);
    tft.setTextColor(ILI9341_WHITE);
    tft.setCursor(43, 48);
    tft.println("Set Default USR Table");
    Menu_Changed = true;


    // Default Memory Tables
  } else if ( (p.x > 35) && (p.x < 300) && (p.y > 78) && (p.y < 98)) {
    tft.setFont(Arial_16);
    tft.fillRect(41, 77, 268, 23, ILI9341_WHITE);
    tft.setTextColor(ILI9341_RED);
    tft.setCursor(43, 78);
    tft.println("Writing Memory Tables");
    Write_Default_Memory_Tables();
    delay(1000);
    tft.fillRect(41, 77, 268, 23, ILI9341_BLUE);
    tft.setTextColor(ILI9341_WHITE);
    tft.setCursor(43, 78);
    tft.println("Set Default Memory Tables");
    Menu_Changed = true;

    // OSC LOAD
  } else if ( (p.x > 35) && (p.x < 300) && (p.y > 108) && (p.y < 128)) {
    Do_OSC_Load();
    Menu_Changed = true;

    // CAT Baud Rate
  } else if ( (p.x > 35) && (p.x < 300) && (p.y > 138) && (p.y < 158)) {
    Do_Baud_Select();
    Menu_Changed = true;

    // Set Screen Calibration
  } else if ( (p.x > 35) && (p.x < 300) && (p.y > 168) && (p.y < 188)) {
    if ( Set_Left_Button_Pressed() == 1) {
      // while ( Set_Left_Button_Pressed() == 1) delay(10);
      while ( Set_Left_Button_Pressed() == 0) delay(10);
      //  Get_Mouse_Data();
      if ( Really()) Calibrate_Screen();
    } else if ( Really() ) Calibrate_Screen();
    Menu_Changed = true;

    // Exit
  } else if ( (p.x > 35) && (p.x < 300) && (p.y > 198) && (p.y < 218)) retval = false;

  if ( Menu_Changed == true ) {
    Display_Configuration2_Menu();
  }
  return (retval);

}





void Do_Configuration2(void) {
  bool looper = true;

  tft.fillScreen(ILI9341_BLUE);
  Display_Configuration2_Menu();

  while ( looper ) {
    if (ts.touched()) {
      Get_Touch( true );
      looper = Process_Config2();
    }
    if (Set_Left_Button_Pressed() == 1) {
      while ( Set_Left_Button_Pressed() == 1) Fake_Delay();
      looper = Process_Config2();
    }
  }
  LastSmeter = 0;
}
///////////////////////////////////////////////////////////////////


